> ## Documentation Index
> Fetch the complete documentation index at: https://help.teable.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Insert attachments at anchor

> Insert attachments after the anchor in the cell (append to end if anchor not found or not provided)



## OpenAPI

````yaml /swagger.json post /table/{tableId}/record/{recordId}/{fieldId}/insertAttachment
openapi: 3.0.0
info:
  version: 1.0.0
  title: Teable App
  description: Manage Data as easy as drink a cup of tea
  x-logo:
    backgroundColor: '#F0F0F0'
    altText: Teable logo
servers:
  - url: https://app.teable.ai/api
security: []
paths:
  /table/{tableId}/record/{recordId}/{fieldId}/insertAttachment:
    post:
      tags:
        - record
      summary: Insert attachments at anchor
      description: >-
        Insert attachments after the anchor in the cell (append to end if anchor
        not found or not provided)
      parameters:
        - schema:
            type: string
          required: true
          name: tableId
          in: path
        - schema:
            type: string
          required: true
          name: recordId
          in: path
        - schema:
            type: string
            description: ID of an attachment field
          required: true
          description: ID of an attachment field
          name: fieldId
          in: path
      requestBody:
        description: Attachments to insert and optional anchor position
        required: true
        content:
          application/json:
            schema:
              type: object
              properties:
                attachments:
                  type: array
                  items:
                    type: object
                    properties:
                      id:
                        type: string
                      name:
                        type: string
                      path:
                        type: string
                      token:
                        type: string
                      size:
                        type: number
                      mimetype:
                        type: string
                      presignedUrl:
                        type: string
                      width:
                        type: number
                      height:
                        type: number
                      smThumbnailUrl:
                        type: string
                      lgThumbnailUrl:
                        type: string
                    required:
                      - id
                      - name
                      - path
                      - token
                      - size
                      - mimetype
                  minItems: 1
                anchorId:
                  type: string
              required:
                - attachments
      responses:
        '201':
          description: Returns record data after update.
          content:
            application/json:
              schema:
                type: object
                properties:
                  id:
                    type: string
                    description: The record id.
                  name:
                    type: string
                    description: primary field value
                  fields:
                    type: object
                    additionalProperties:
                      nullable: true
                    description: >-
                      Objects with a fields key mapping fieldId or field name to
                      value for that field.
                  autoNumber:
                    type: number
                    description: Auto number, a unique identifier for each record
                  createdTime:
                    type: string
                    description: Created time, date ISO string (new Date().toISOString).
                  lastModifiedTime:
                    type: string
                    description: >-
                      Last modified time, date ISO string (new
                      Date().toISOString).
                  createdBy:
                    type: string
                    description: Created by, user name
                  lastModifiedBy:
                    type: string
                    description: Last modified by, user name
                  permissions:
                    type: object
                    additionalProperties:
                      type: object
                      additionalProperties:
                        type: boolean
                    description: Permissions for the record
                  undeletable:
                    type: boolean
                    description: Whether the record is undeletable
                required:
                  - id
                  - fields
      security:
        - bearerAuth: []
      x-codeSamples:
        - lang: Shell
          source: |-
            curl --request POST \
              --url https://app.teable.ai/api/table/%7BtableId%7D/record/%7BrecordId%7D/%7BfieldId%7D/insertAttachment \
              --header 'Authorization: Bearer REPLACE_BEARER_TOKEN' \
              --header 'content-type: application/json' \
              --data '{"attachments":[{"id":"string","name":"string","path":"string","token":"string","size":0,"mimetype":"string","presignedUrl":"string","width":0,"height":0,"smThumbnailUrl":"string","lgThumbnailUrl":"string"}],"anchorId":"string"}'
        - lang: JavaScript
          source: >-
            const url =
            'https://app.teable.ai/api/table/%7BtableId%7D/record/%7BrecordId%7D/%7BfieldId%7D/insertAttachment';

            const options = {
              method: 'POST',
              headers: {
                Authorization: 'Bearer REPLACE_BEARER_TOKEN',
                'content-type': 'application/json'
              },
              body: '{"attachments":[{"id":"string","name":"string","path":"string","token":"string","size":0,"mimetype":"string","presignedUrl":"string","width":0,"height":0,"smThumbnailUrl":"string","lgThumbnailUrl":"string"}],"anchorId":"string"}'
            };


            try {
              const response = await fetch(url, options);
              const data = await response.json();
              console.log(data);
            } catch (error) {
              console.error(error);
            }
        - lang: Node.js
          source: |-
            const http = require('https');

            const options = {
              method: 'POST',
              hostname: 'app.teable.ai',
              port: null,
              path: '/api/table/%7BtableId%7D/record/%7BrecordId%7D/%7BfieldId%7D/insertAttachment',
              headers: {
                Authorization: 'Bearer REPLACE_BEARER_TOKEN',
                'content-type': 'application/json'
              }
            };

            const req = http.request(options, function (res) {
              const chunks = [];

              res.on('data', function (chunk) {
                chunks.push(chunk);
              });

              res.on('end', function () {
                const body = Buffer.concat(chunks);
                console.log(body.toString());
              });
            });

            req.write(JSON.stringify({
              attachments: [
                {
                  id: 'string',
                  name: 'string',
                  path: 'string',
                  token: 'string',
                  size: 0,
                  mimetype: 'string',
                  presignedUrl: 'string',
                  width: 0,
                  height: 0,
                  smThumbnailUrl: 'string',
                  lgThumbnailUrl: 'string'
                }
              ],
              anchorId: 'string'
            }));
            req.end();
        - lang: Python
          source: >-
            import http.client


            conn = http.client.HTTPSConnection("app.teable.ai")


            payload =
            "{\"attachments\":[{\"id\":\"string\",\"name\":\"string\",\"path\":\"string\",\"token\":\"string\",\"size\":0,\"mimetype\":\"string\",\"presignedUrl\":\"string\",\"width\":0,\"height\":0,\"smThumbnailUrl\":\"string\",\"lgThumbnailUrl\":\"string\"}],\"anchorId\":\"string\"}"


            headers = {
                'Authorization': "Bearer REPLACE_BEARER_TOKEN",
                'content-type': "application/json"
            }


            conn.request("POST",
            "/api/table/%7BtableId%7D/record/%7BrecordId%7D/%7BfieldId%7D/insertAttachment",
            payload, headers)


            res = conn.getresponse()

            data = res.read()


            print(data.decode("utf-8"))
components:
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer

````